﻿Type=Activity
Version=2.71
@EndOfDesignText@
#Region  Activity Attributes 
	#FullScreen: False
	#IncludeTitle: True
	#ExcludeFromLibrary: True
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.

End Sub

Sub Globals
	'These global variables will be redeclared each time the activity is created.
	'These variables can only be accessed from this module.
	Private bActivityCreated As Boolean = False
	Private camEx As CameraExClass
	Private frontCamera As Boolean = False
	Private bCameraActive As Boolean
	Private dir As String = File.DirDefaultExternal
	Private filename As String = "TMPPhoto.jpg"
	Dim BmpPhoto As Bitmap
	Dim CanvasPhoto As Canvas

	Dim Bmp As Bitmap
	Dim btnSave As Button
	Dim btnCancel As Button
	Dim btnDelete As Button
	Dim edtFName As EditText
	Dim edtLName As EditText
	Dim edtBirthDate As Label
	Dim imgDate As ImageView
	Dim bActive As CheckBox
	Dim cbMaleFemale As Spinner
	Dim scrlDetails As ScrollView
	Dim pnlTop As Panel
	Dim imgPhoto As ImageView
	Dim pnlPhoto As Panel
	Dim btnCamera As ImageView
	Dim btnClearPhoto As ImageView
	Dim btnChangeCamera As ImageView
	Dim btnCloseCamera As ImageView
	Dim edtNotes As EditText
End Sub

Sub Activity_Create(FirstTime As Boolean)
	'Do not forget to load the layout file created with the visual designer. For example:
	'Activity.LoadLayout("Layout1")
	Activity.LoadLayout("EditForm")
	Bmp.Initialize(File.DirAssets, "calendar_icon.png")	
	If FirstTime Then
	    cbMaleFemale.Add("")
		cbMaleFemale.Add("Male")
		cbMaleFemale.Add("Female")
	End If
End Sub

Sub Activity_Resume
	scrlDetails.Panel.Height = pnlTop.Height
	pnlTop.RemoveView
	scrlDetails.Panel.AddView(pnlTop, 0, 0, pnlTop.Width, pnlTop.Height)
	btnCamera.Visible = True
	btnClearPhoto.Visible = True
	btnChangeCamera.Visible = False
	btnCloseCamera.Visible = False	
	bActivityCreated = False
	btnDelete.Enabled = (Main.MySQLDataset.State = CodDB.dsBrowse)
	btnSave.Enabled = (Main.MySQLDataset.State = CodDB.dsinsert OR Main.MySQLDataset.State = CodDB.dsedit)	
	bActive.Checked = Main.MySQLDataset.FieldByName("bActive").AsBoolean
	
	If Main.MySQLDataset.FieldByName("strMaleFemale").AsString = "MALE" Then
		cbMaleFemale.SelectedIndex = 1
	Else If Main.MySQLDataset.FieldByName("strMaleFemale").AsString = "FEMALE" Then
		cbMaleFemale.SelectedIndex = 2
	Else
		cbMaleFemale.SelectedIndex = 0
	End If
	edtFName.Text = Main.MySQLDataset.FieldByName("strFirstName").AsString
	edtLName.Text = Main.MySQLDataset.FieldByName("strLastName").AsString
	If Main.MySQLDataset.FieldByName("dBirthDate").AsDateTime <> 0 Then
		edtBirthDate.Text = DateTime.Date(Main.MySQLDataset.FieldByName("dBirthDate").AsDateTime)
	Else
		edtBirthDate.Text = "";
	End If
	
	If Not(Main.MySQLDataset.FieldByName("objPhoto").IsNull) Then
		Dim bt() As Byte = Main.MySQLDataset.FieldByName("objPhoto").AsBytes
 		Dim In As InputStream
		If  bt <> Null Then
		Try
			In.InitializeFromBytesArray(bt, 0, bt.Length)
			BmpPhoto.Initialize2(In)
			imgPhoto.Bitmap = BmpPhoto
			imgPhoto.Visible = True
			pnlPhoto.Visible = False
		Catch
			Log("Error loading bitmap")
		End Try
		
'		imgPhoto.Bitmap = LoadBitmap(dir, filename) 		
	'pnlPhoto.Bitmap = LoadBitmap(File.DirAssets, "someimage.jpg")	
	'imgPhoto.Visible = False
		End If
	Else
		imgPhoto.Bitmap = Null
	End If
	edtNotes.Text = Main.MySQLDataset.FieldByName("mNotes").AsString
		
	Main.MySQLDataset.Module = Me
	bActivityCreated = True
End Sub

Sub Activity_Pause (UserClosed As Boolean)
	DestroyCamera
End Sub

Sub btnSave_Click
	Main.MySQLDataset.FieldByName("bActive").AsBoolean = bActive.Checked
	If cbMaleFemale.SelectedIndex = 0 Then
		Main.MySQLDataset.FieldByName("strMaleFemale").Value = Null
	Else If cbMaleFemale.SelectedIndex = 1 Then
		Main.MySQLDataset.FieldByName("strMaleFemale").AsString = "MALE"
	Else If cbMaleFemale.SelectedIndex = 2 Then
		Main.MySQLDataset.FieldByName("strMaleFemale").AsString = "FEMALE"
	End If	
	Main.MySQLDataset.FieldByName("strFirstName").AsString = edtFName.Text
	Main.MySQLDataset.FieldByName("strLastName").AsString = edtLName.Text
	Log(edtBirthDate.Text.Trim)
	If edtBirthDate.Text.Trim <> "" Then Main.MySQLDataset.FieldByName("dBirthDate").AsDateTime = DateTime.DateParse(edtBirthDate.Text)
	
	If imgPhoto.Bitmap = Null Then
		Main.MySQLDataset.FieldByName("objPhoto").SetValue(Null)
	Else
		Main.MySQLDataset.FieldByName("objPhoto").setAsBitmap(imgPhoto.Bitmap, 75)
	End If
	
	Main.MySQLDataset.FieldByName("mNotes").AsString = edtNotes.Text
	
	Main.MySQLDataset.OnBeforePost = "OnBeforePost"
	Main.MySQLDataset.Post	
	StartActivity("Main")	
	'Activity.Finish
End Sub

Sub OnBeforePost(DBMySQLDataset As ClsDBMySQLDataset)
	ProgressDialogShow("Saving record")
End Sub

Private Sub FieldChange
	If Not(bActivityCreated) Then Return
	
	If Main.MySQLDataset.State <> CodDB.dsInsert AND Main.MySQLDataset.State <> CodDB.dsEdit Then	
		Main.MySQLDataset.Edit
	End If
	
	btnSave.Enabled = (Main.MySQLDataset.State = CodDB.dsinsert OR Main.MySQLDataset.State = CodDB.dsedit)	
End Sub

Sub bActive_CheckedChange(Checked As Boolean)
	FieldChange
End Sub

Sub cbMaleFemale_ItemClick (Position As Int, Value As Object)
	FieldChange	
End Sub

Sub edtFName_TextChanged (Old As String, New As String)
	FieldChange
End Sub

Sub edtLName_TextChanged (Old As String, New As String)
	FieldChange	
End Sub

Sub edtBirthDate_TextChanged (Old As String, New As String)
	FieldChange
End Sub

Sub imgDate_Click
	Dim dStart As Long
	Dim Dd As DateDialog

	dStart = DateTime.Now
	If edtBirthDate.Text <> "" Then
		Try
			dStart = DateTime.DateParse(edtBirthDate.Text)
		Catch
		End Try
	End If
	Dd.ShowCalendar = False
	Dd.Year = DateTime.GetYear(dStart)
	Dd.Month = DateTime.GetMonth(dStart)	
	Dd.DayOfMonth = DateTime.GetDayOfMonth(dStart)
	ret = Dd.Show("Select Date", "Birth Date", "OK", "Cancel", "", Bmp)
	If ret  = DialogResponse.POSITIVE Then
		edtBirthDate.Text = DateTime.Date(Dd.DateTicks)
	End If	
End Sub

Sub edtBirthDate_Click
	imgDate_Click	
End Sub

Sub btnCancel_Click
	Main.MySQLDataset.Cancel
	StartActivity("Main")
End Sub

Sub btnDelete_Click
	If Main.MySQLDataset.State = CodDB.dsEdit OR Main.MySQLDataset.State = CodDB.dsInsert Then
		Main.MySQLDataset.Cancel
	End If		
	
	If Msgbox2("Do you want to delete the record?", "Delete", "Yes", "Cancel", "No", Null) = DialogResponse.Positive Then
		Main.MySQLDataset.Delete
		StartActivity("Main")
	End If
End Sub

Sub btnCamera_Click
	'imgPhoto.Visible = False
	If bCameraActive Then
		camEx.TakePicture
	Else
		InitializeCamera
	End If
End Sub

Private Sub InitializeCamera
'	btnCamera.Visible = False
	btnClearPhoto.Visible = False
	btnChangeCamera.Visible = True
	btnCloseCamera.Visible = True
	imgPhoto.Visible = False
	camEx.Initialize(pnlPhoto, frontCamera, Me, "btnCameraEvent")
	frontCamera = camEx.Front
End Sub

Private Sub DestroyCamera
'	btnCamera.Visible = True
	btnClearPhoto.Visible = True
	btnChangeCamera.Visible = False
	btnCloseCamera.Visible = False
	If bCameraActive Then camEx.Release
	bCameraActive = False
	imgPhoto.Visible = True
End Sub

Sub btnCameraEvent_Ready (Success As Boolean)
	If Success Then
		camEx.StartPreview
		camEx.SetJpegQuality(75)
		camEx.CommitParameters
		bCameraActive = True
	Else
		ToastMessageShow("Cannot open camera.", True)
	End If
End Sub

Sub btnCameraEvent_PictureTaken (Data() As Byte)	
	camEx.SavePictureToFile(Data, dir, filename)
	camEx.StopPreview
	ToastMessageShow("Picture saved in ." & dir & "/" & filename & CRLF  & "File size: " & File.Size(dir, filename), True)
	
	imgPhoto.Bitmap = LoadBitmap(dir, filename) 
	FieldChange
	DestroyCamera

'	camEx.StartPreview 'restart preview
'	
'	'send a broadcast intent to the media scanner to force it to scan the saved file.
'	Dim Phone As Phone
'	Dim i As Intent
'	i.Initialize("android.intent.action.MEDIA_SCANNER_SCAN_FILE", _
'		"file://" & File.Combine(dir, filename))
'	Phone.SendBroadcastIntent(i)
'	ToastMessageShow("Picture saved." & CRLF  & "File size: " & File.Size(dir, filename), True)
End Sub

Sub btnClearPhoto_Click
	imgPhoto.Bitmap = Null
End Sub

Sub btnChangeCamera_Click
	camEx.Release
	frontCamera = Not(frontCamera)
	InitializeCamera	
End Sub

Sub btnCloseCamera_Click
	DestroyCamera
End Sub

Sub edtNotes_TextChanged (Old As String, New As String)
	FieldChange	
End Sub